import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color; // import colour library
/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Mover
{   
    private static final int jumpStrength = 25;
    
    private int level;
    
    boolean canMove;
    float ys, xs;
    int x,y;
    int scrollSpeed;
    int hits = 0;
    ground Ground = new ground();
    boolean hasBeenBounced;
    
    private GreenfootImage crownRight = new GreenfootImage("Doodle1.png");
    private GreenfootImage crownLeft = new GreenfootImage("Doodle1Flip.png");
    
    public void changeLevel(int newLevel)
    {
       level = newLevel;  
    }
    
        /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */

    public Player()
    {
        canMove = true;
    }
    
     /**
     *can check whether the move
     */
    public Player(boolean moveable)
    {
        canMove = moveable;
    }

    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
       
        checkKeys(); // check if the player is pressing left, right or jump
       checkFall(); // check if the player should be falling
       checkOnBottom(); // check if the player is touching the bottom
       checkPowerUp();
       
       shoot();
       eat();
       
        x = getX();
        y = getY();

        ((MyWorld) getWorld()).PlayerX = getX();
        
        if(((MyWorld) getWorld()).fall==false)
        {
            bounce();
        }
        if(canMove) {
            checkKeys();
        }
        if(ys>11) {
            ys = 10;
        }
        
        setLocation(x+(int)xs, y+(int)ys);

        gravity();

        
        if(canMove & y < 400) {
            scrollUp();
        }
        if(y>400) {
            fall();
        }
        ((MyWorld) getWorld()).height = hits;
        
         MyWorld theWorld = (MyWorld) getWorld();
        boolean powerUpState = theWorld.getPowerUp();
        
        if(powerUpState == false)
        {
            //postMessage("triggered: " + powerUpState);
            crownRight = new GreenfootImage("Doodle1.png");
            crownLeft = new GreenfootImage("Doodle1Flip.png");
            
        }

    }    
    
    public void checkPowerUp()
    {
        
        MyWorld theWorld = (MyWorld) getWorld();
        boolean powerUpState = theWorld.getPowerUp();
        //postMessage("powerup: " + powerUpState);
        if(powerUpState == true)
        {
            //postMessage("triggered2: " + powerUpState);
            crownRight = new GreenfootImage("DoodleCrown1.png");
            crownLeft = new GreenfootImage("DoodleCrown2.png");
            
        } 
        
    }

    
        
    private void checkOnBottom()
    {
       int bottom = getWorld().getHeight() - 3;
       if( getY() >= bottom )
       {
          getWorld().removeObject(this) ;
       }
    }
    
    private void checkKeys()
    {
       // if the player presses the left arrow move left
       if( Greenfoot.isKeyDown("left") )
       {
         moveLeft();  
         setImage(crownLeft);
       }
       // if the player presses the right arrow move right
       if( Greenfoot.isKeyDown("right") )
       {
         moveRight();  
         setImage(crownRight);
       }
       // if the player presses the space bar, jump
    }
    
    private void jump()
    {
       setVSpeed(-jumpStrength);
       fall();
    }
    
    private void checkFall()
    {
       if( onGround() )
       {
         setVSpeed(0);  
       } else
       {
         fall();   
       }
    }
    
        /**
     * Return true if we're at the bottom of the screen.
     */
    private boolean atBottom()
    {
       int bottom = getWorld().getHeight() - 3;
       if( getY() >= bottom )
       {
          getWorld().removeObject(this) ;
          return true;
       } else {
       return false;
       
    }
    } // ugh

    
        public void fall()
    {
        ((MyWorld) getWorld()).fall = true;
        ((MyWorld) getWorld()).scrollSpeed = (int) -ys;

    }
    
       /**
     * Changing the speed jump (deceleration, acceleration in flight)
     */
    public void scrollUp()
    {
        //postMessage("Scroll y: " + y);
        if(y<=200 & y>100)
        {
            ((MyWorld) getWorld()).scrollSpeed = (int) -ys;
            ((MyWorld) getWorld()).scroll = true;
            hits++;
            
        }
        else if(y<=100)
        {
            ((MyWorld) getWorld()).scrollSpeed = (int) -ys*2;
            ((MyWorld) getWorld()).scroll = true;
            hits++;
        }

        else
        {
            ((MyWorld) getWorld()).scroll = false;
        }
    }

    
        /**
     * We touch the ground, jump up and generate new land islands
     */
    public void bounce()
    {
        ground Ground = (ground) getOneIntersectingObject(ground.class);
        if(Ground != null & ys > 0)
        {
            ys = -10;
            
            if(canMove & !Ground.hasBeenBounced)
            {
                Ground.hasBeenBounced=true;
                {
                    getWorld().addObject(new ground2(), Greenfoot.getRandomNumber(500), 70);
                    getWorld().addObject(new ground(), Greenfoot.getRandomNumber(500), 70);
                }
            }
        }
    }
    
    /**
     * gravity correction
    */
    public void gravity()
    {
        ys += 0.3f;
    }
    
    private int shotTimer = 0;
    
    public void shoot()
    {
             if (shotTimer > 0 ) {
          shotTimer = shotTimer -1;
        } 
      else if (Greenfoot.isKeyDown("space") )
        {
         getWorld().addObject(new Missile(), getX(), getY() -25 );
         shotTimer = 30;
        }
     
    }
    
    private void postMessage(String message) 
    {
        MyWorld theWorld = (MyWorld) getWorld(); //find the world of level
        Debug debugBox = theWorld.getDegbug(); 
        debugBox.debugMessage(message);
    }
   

     
     public void eat()
    {      // Eat the Food
        Actor Food = getOneIntersectingObject(Food.class);
        if(Food !=null) {
            // this happens when we are touching Food
            getWorld().removeObject(Food);
            MyWorld theWorld = (MyWorld) getWorld();
            theWorld.setPowerUp(true);
            
        }
    }
    

}
